openjfx_dir=/usr/share/java/openjfx/
openjdk_dir=/usr/lib/jvm/java-8-openjdk-amd64/
working_dir=$PWD

release_jre_build=$(echo $working_dir/build/*release/images/j2re-image)
release_jdk_build=$(echo $working_dir/build/*release/images/j2sdk-image)

fastdebug_jre_build=$(echo $working_dir/build/*fast*/images/j2re-image)
fastdebug_jdk_build=$(echo $working_dir/build/*fast*/images/j2sdk-image)

slowdebug_jre_build=$(echo $working_dir/build/*slow*/images/j2re-image)
slowdebug_jdk_build=$(echo $working_dir/build/*slow*/images/j2sdk-image)

if [ -e $openjfx_dir ]
then
	for build_dir in $release_jre_build $release_jdk_build $fastdebug_jre_build $fastdebug_jre_build $slowdebug_jre_build $slowdebug_jdk_build
	do
		if [ -e $build_dir ] 
		then 
			echo "Copying JavaFX files to $build_dir"
			pushd "$openjfx_dir"
			find . -iname "*.jar" | cpio -pdm  $build_dir
			find . -iname "*.properties" | cpio -pdm  $build_dir
			

			count=$(echo "$openjdk_dir" | wc -c)
			for file in $(dpkg-query -L libopenjfx-jni | grep .so)
			do
				echo $file
				file=$(bash -c "file=$file && echo "'${'"file"':$(('"$count"'-2))}')
				echo $file
				rm -f "$build_dir/$file"
				mkdir -p $(dirname "$build_dir/$file")
				cp "$openjdk_dir/$file" "$build_dir/$file"
			done
			popd
		fi
	done
fi